#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed" if ! -r $confGanglia;

$ip   = "239.2.11.71";
$port = "8649";

open(IN,"$confGanglia") || die "Cannot read $confGanglia";
while (<IN>)
  {
    next if /^#/;
    $ip   = $1 if /mcast_channel +(.*)/;
    $port = $1 if /mcast_port +(.*)/;
  }
close IN;

my @top = split(/\n/,`top -b -n1`);

do
  {
    $t = shift @top;
  }
  while (!($t =~ /PID USER     PRI  NI  SIZE/));

for (my $i=1; $i<=5; $i++)
  {
    my $t = shift @top;
    $t =~ s/^ *//; # remove leading spaces
    my @t = split(/ +/,$t);

    my $user = $t[1];
    my $cmd  = pop @t;
    my $time = pop @t;
    my $mem  = pop @t;
    my $cpu  = pop @t;

    my $val  = "$user/$cpu/$time/$cmd";

    my $exec = "$confGmetric -c$ip -p$port -tstring -n\"top_$i\" -v\"$val\"";
    #print "$exec\n";
    system $exec;
  }

exit 0;
#end file
